# Ingress
One of the final tasks of the Ascend final project was implementing an ingress for our Kubernetes cluster. Although we were unable to implement an ingress prior to giving the internal demo, an ingress was successfully created for the cluster's backend services. Ideally, an ingress would be created for the frontend services as well, and sequestered behind one public-facing IP, however due to time constraints and the time required to both register DNSes and get them approved for Google OAuth, the team met the requirements in a different way.
### Configuring an ingress for an Azure-deployed Kubernetes cluster
(The following walkthrough assumes the reader has access to the Azure-hosted Kubernetes cluster via kubectl)

* Clone into this repo on your local machine and navigate to root
    ```sh
    git clone https://gitlab.mynisum.com/ascend/ingress
    cd ingress
    ```

* Install the Ingress controller from the official Kubernetes nginx ingress (Reference: https://kubernetes.github.io/ingress-nginx/deploy/)
    ```sh
    kubectl apply -f https://raw.githubusercontent.com/kubernetes/ingress-nginx/controller-v0.46.0/deploy/static/provider/cloud/deploy.yaml
    ```
    
* Deploy the configuration file (warning: if any specifications of the project files have changed, this deployment.yaml may no longer work)
    ```sh
    kubectl apply -f deployment.yaml
    ```

The deployment.yaml file was written with the intention that flags need not be passed after the apply command, so any changes that need to be made (say, to the Kubernetes namespace) should be changed in the yaml file itself, so that domain-specific knowledge is captured in the repo history.